Part Ellipse: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
 
(7 intermediate revisions by 2 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
{{UnfinishedDocu{{#translation:}}}}
<translate>
<translate>


Line 24: Line 23:


<!--T:5-->
<!--T:5-->
A [[Image:Part_Ellipse.svg|24px]] '''Part Ellipse''' is a parametric shape that can be created with the [[Image:Part_Primitives.svg|24px]] [[Part_Primitives|Part Primitives]] command. In the coordinate system defined by its {{PropertyData|Placement}} property, the ellipse lies on the XY plane with its center at the origin. Its mayor axis is parallel to the X axis.
The [[Image:Part_Ellipse.svg|24px]] [[Part_Ellipse|Part Ellipse]] command creates a parametric ellipse shape.


<!--T:10-->
FreeCAD creates an ellipse, with default values for major and minor radius and the angles for the start and end point of the curve.
A Part Ellipse is in fact a closed counterclockwise elliptical arc, it can be turned into an arc by changing its {{PropertyData|Angle1}} and/or {{PropertyData|Angle2}} properties.


</translate>
By default, the ellipse is positioned with its center point at the origin (0,0,0). Its major radius goes to the x-direction. The minor radius goes to the y-direction. The shape lays on the xy-area.
[[Image:Part_Ellipse_Example.png|400px]]

<translate>
[[File:Part Ellipse Example.png|Screenshot of Part Ellipse]]


== Usage == <!--T:7-->
== Usage == <!--T:7-->


<!--T:4-->
<!--T:11-->
See [[Part_Primitives#Usage|Part Primitives]].
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:Part_Primitives.svg|16px]] [[Part Primitives|Create Primitives...]]}} button.
#* Select the {{MenuCommand|Part → Create Primitives → [[Image:Part_Primitives.svg|16px]] Create Primitives...}} option from the menu.
#* Select the {{MenuCommand|[[Image:Part_Ellipse.svg|16px]] Ellipse}} option from the menu.
# Set options and press {{Button|Create}}.
# To close the dialog press {{Button|Close}}.


== Example ==
== Example == <!--T:12-->


<!--T:13-->
[[File:Part Ellipse Scripting Example.png|thumb|Part Ellipse scripting example]]
[[Image:Part_Ellipse_Scripting_Example.png|thumb|Part Ellipse from the scripting example]]


<!--T:14-->
A Part Ellipse object with the values of the bottom scripting example are shown here.
A Part Ellipse object created with the [[#Scripting|scripting example]] below is shown here.


== Properties ==
== Properties == <!--T:15-->


<!--T:16-->
See also: [[Property_editor|Property editor]].
See also: [[Property_editor|Property editor]].


<!--T:17-->
A Part Ellipse object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
A Part Ellipse object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:


=== Data ===
=== Data === <!--T:18-->


<!--T:19-->
{{TitleProperty|Box}}
{{TitleProperty|Attachment}}


<!--T:20-->
* {{PropertyData|MajorRadius|Length}}: The major radius of the ellipse. This is the dimension in the x-direction.
The object has the same attachment properties as a [[Part_Part2DObject#Data|Part Part2DObject]].
* {{PropertyData|MinorRadius|Length}}: The major radius of the ellipse. This is the dimension in the y-direction.
* {{PropertyData|Angle1|Angle}}: The first angle of the ellipse. This is the angle for the start point of the curve.
* {{PropertyData|Angle2|Angle}}: The second angle of the ellipse. This is the angle for the end point of the curve.


<!--T:21-->
== Scripting ==
{{TitleProperty|Base}}


<!--T:22-->
A Part Box is created with the {{Incode|addObject()}} method of the document.
* {{PropertyData|MajorRadius|Length}}: The major radius of the ellipse or elliptical arc. The default is {{Value|4mm}}.
* {{PropertyData|MinorRadius|Length}}: The minor radius of the ellipse or elliptical arc. The default is {{Value|2mm}}.
* {{PropertyData|Angle1|Angle}}: The start angle of the elliptical arc. Valid range: {{Value|0° &lt; value &lt;&#61; 360°}}. The default is {{Value|0°}}.
* {{PropertyData|Angle2|Angle}}: The end angle of the elliptical arc. Valid range: {{Value|0° &lt; value &lt;&#61; 360°}}. The default is {{Value|360°}}. If {{PropertyData|Angle1}} and {{PropertyData|Angle2}} are equal, or if one angle is {{Value|0°}} and the other {{Value|360°}}, a full ellipse is created.

== Scripting == <!--T:23-->

<!--T:24-->
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation], [[Part_scripting|Part scripting]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].

<!--T:25-->
A Part Ellipse can be created with the {{Incode|addObject()}} method of the document:


</translate>
</translate>
Line 73: Line 84:
<translate>
<translate>


<!--T:26-->
* Where {{Incode|myBox}} is the name for the object. The name must be unique for the entire document.
* Where {{Incode|"myEllipse"}} is the name for the object.
* The function returns the newly created object.
* The function returns the newly created object.


<!--T:27-->
The {{Incode|Label}} is the user editable name for the object. It can be easily changed by
Example:


</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD as App
ellipse.label = "new ellipseName"
}}
<translate>


doc = App.activeDocument()
You can access and modify attributes of the {{Incode|box}} object. For example, you may wish to modify the two radii and angles of the ellipse.


ellipse = doc.addObject("Part::Ellipse", "myEllipse")
</translate>
{{Code|code=
ellipse.MajorRadius = 20
ellipse.MajorRadius = 20
ellipse.MinorRadius = 10
ellipse.MinorRadius = 10
ellipse.Angle1 = 45
ellipse.Angle1 = 45
ellipse.Angle2 = 135
ellipse.Angle2 = 135
ellipse.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()
}}
}}
<translate>
<translate>


The result will be a part of an ellipse.

You can change its placement and orientation with:

</translate>
{{Code|code=
ellipse.Placement = FreeCAD.Placement(FreeCAD.Vector(1, 2, 3), FreeCAD.Rotation(30, 45, 10))
}}
<translate>


<!--T:9-->
<!--T:9-->
Line 116: Line 120:


</translate>
</translate>
{{Part Tools navi{{#translation:}}}}
{{Part_Tools_navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 10:25, 3 March 2022

Part Ellipse

Menu location
Part → Create primitives → Ellipse
Workbenches
Part, OpenSCAD
Default shortcut
None
Introduced in version
-
See also
Part Primitives

Description

A Part Ellipse is a parametric shape that can be created with the Part Primitives command. In the coordinate system defined by its DataPlacement property, the ellipse lies on the XY plane with its center at the origin. Its mayor axis is parallel to the X axis.

A Part Ellipse is in fact a closed counterclockwise elliptical arc, it can be turned into an arc by changing its DataAngle1 and/or DataAngle2 properties.

Usage

See Part Primitives.

Example

Part Ellipse from the scripting example

A Part Ellipse object created with the scripting example below is shown here.

Properties

See also: Property editor.

A Part Ellipse object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Attachment

The object has the same attachment properties as a Part Part2DObject.

Base

  • DataMajorRadius (Length): The major radius of the ellipse or elliptical arc. The default is 4mm.
  • DataMinorRadius (Length): The minor radius of the ellipse or elliptical arc. The default is 2mm.
  • DataAngle1 (Angle): The start angle of the elliptical arc. Valid range: 0° < value <= 360°. The default is .
  • DataAngle2 (Angle): The end angle of the elliptical arc. Valid range: 0° < value <= 360°. The default is 360°. If DataAngle1 and DataAngle2 are equal, or if one angle is and the other 360°, a full ellipse is created.

Scripting

See also: Autogenerated API documentation, Part scripting and FreeCAD Scripting Basics.

A Part Ellipse can be created with the addObject() method of the document:

ellipse = FreeCAD.ActiveDocument.addObject("Part::Ellipse", "myEllipse")
  • Where "myEllipse" is the name for the object.
  • The function returns the newly created object.

Example:

import FreeCAD as App

doc = App.activeDocument()

ellipse = doc.addObject("Part::Ellipse", "myEllipse")
ellipse.MajorRadius = 20
ellipse.MinorRadius = 10
ellipse.Angle1 = 45
ellipse.Angle2 = 135
ellipse.Placement = App.Placement(App.Vector(1, 2, 3), App.Rotation(30, 45, 10))

doc.recompute()